/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech) (5.1.0).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
package be.lghs.accounting.api.generated.controller;

import be.lghs.accounting.api.generated.model.Movement;
import io.swagger.annotations.*;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.context.request.NativeWebRequest;
import org.springframework.web.multipart.MultipartFile;
import springfox.documentation.annotations.ApiIgnore;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
import java.util.Map;
import java.util.Optional;
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2022-10-09T15:10:45.039Z[GMT]")
@Validated
@Api(value = "movements", description = "the movements API")
public interface MovementsApi {

    default Optional<NativeWebRequest> getRequest() {
        return Optional.empty();
    }

    /**
     * GET /movements : All movements
     *
     * @return OK (status code 200)
     */
    @ApiOperation(value = "All movements", nickname = "allMovements", notes = "", response = Movement.class, responseContainer = "List", tags={ "movements", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = Movement.class, responseContainer = "List") })
    @GetMapping(
        value = "/movements",
        produces = { "application/json" }
    )
    default ResponseEntity<List<Movement>> allMovements() {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    String exampleString = "{ \"amount\" : 0, \"entryDate\" : \"\", \"from\" : \"from\", \"id\" : \"id\", \"communication\" : \"communication\", \"category\" : \"category\" }";
                    ApiUtil.setExampleResponse(request, "application/json", exampleString);
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }

}
